package edu.ntnu.stud.chaosgame.controller.game;

import javafx.geometry.Point2D;
import javafx.scene.shape.Rectangle;

public class Quadtree {
  private QuadtreeNode root;

  public Quadtree(Rectangle bounds) {
    root = new QuadtreeNode(bounds, 0);
  }

  public QuadtreeNode findNodeContainingPoint(Point2D point) {
    return findNodeContainingPoint(root, point);
  }

  private QuadtreeNode findNodeContainingPoint(QuadtreeNode node, Point2D point) {
    if (node.isLeaf()) {
      return node;
    }

    for (QuadtreeNode child : node.getChildren()) {
      if (child.getBounds().contains(point)) {
        return findNodeContainingPoint(child, point);
      }
    }

    return null;
  }



  // other methods omitted for brevity
}
